<?php
/**
 * @title Example Module
 * @desc This module is a sample
 */
class Bootstrap_Example extends Am_Module
{
    public function onInitFinished()
    {
        // you can add new routes in this method
    }

    /**
     * You may hook to any event define in amember/library/Am/Event.php file
     * just define in this class a function named onEventName()
     * you may var_dump($event); to see what variables is present in the event
     */
    function onUserInsert(Am_Event $event)
    {
        $user = $event->getUser();
        $this->getDi()->logger->info("DEBUG: example module: user inserted {user}", ['user' => $user]);
    }

    public function getReadme()
    {
        $root = $this->getDi()->url('example');
        return <<<CUT
This module gives you idea how to start your own module development for aMember.
It provides the following controllers:
    <i>controllers/IndexController.php</i> <a href='$root/' target=_blank>link</a> - basic sample how to write controllers
    <i>controllers/DaoController.php</i> <a href='$root/dao' target=_blank>link</a> - database objects usage
    <i>controllers/GridController.php</i> <a href='$root/grid' target=_blank>link</a> - grid usage
    <i>controllers/AdminController.php</i> <a href='$root/admin' target=_blank>link</a> - basic sample how to create admin pages
you may want to look at the following files too:
    <i>db.xml</i> - define database tables (and additional fields to existing tables!)
    <i>Bootstrap.php</i> - module initialization, configuration and hooks class
    <i>library/Example.php</i> - classes to access "am_example" table - for record and entire table
    <i>views/example/index.phtml</i> - a sample template
    <i>views/example/_include.phtml</i> - a sample include file (included into index.phtml)
    
To start your own module based on this, do the following (replace [yourname] to whatever you want):
    * copy <i>amember/application/example</i> to <i>amember/application/yourname</i> folder
    * find and replace in all files "<i>example</i>" and "<i>Example</i>" to "<i>yourname</i>" and "<i>Yourname</i>"
    * make necessary changes to <i>db.xml</i> or remove it if you do not need own tables
    * edit <i>module.xml</i> to match your module 
    * remove unecessary files from <i>amember/application/yourname/controllers</i> folder
    * go to <i>aMember Cp -> Setup -> Plugins</i>, enable "<i>yourname</i>" module and start
       continius testing and development
       
CUT;
    }
}